#! /bin/sh
#
# Copyright (C) 2002-2006 Free Software Foundation, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

# This program is meant for authors or maintainers which want to import
# modules from gnulib into their packages.

progname=$0
package=gnulib
cvsdatestamp='$Date: 2006-07-20 16:53:35 $'
last_checkin_date=`echo "$cvsdatestamp" | sed -e 's,^\$[D]ate: ,,'`
version=`echo "$last_checkin_date" | sed -e 's/ .*$//' -e 's,/,-,g'`

# You can set AUTOCONFPATH to empty if autoconf 2.57 is already in your PATH.
AUTOCONFPATH=
#case $USER in
#  bruno )
#    AUTOCONFBINDIR=/packages/gnu-inst-autoconf/2.57/bin
#    AUTOCONFPATH="eval env PATH=${AUTOCONFBINDIR}:\$PATH "
#    ;;
#esac

# You can set AUTOMAKEPATH to empty if automake 1.9.x is already in your PATH.
AUTOMAKEPATH=

# If you didn't set AUTOCONFPATH and AUTOMAKEPATH, you can also set the
# variables AUTOCONF, ACLOCAL, AUTOMAKE, AUTORECONF individually.
if test -z "${AUTOCONF}" || test -n "${AUTOCONFPATH}"; then
  AUTOCONF="${AUTOCONFPATH}autoconf"
fi
if test -z "${ACLOCAL}" || test -n "${AUTOMAKEPATH}"; then
  ACLOCAL="${AUTOMAKEPATH}aclocal"
fi
if test -z "${AUTOMAKE}" || test -n "${AUTOMAKEPATH}"; then
  AUTOMAKE="${AUTOMAKEPATH}automake"
fi
if test -z "${AUTORECONF}" || test -n "${AUTOCONFPATH}"; then
  AUTORECONF="${AUTOCONFPATH}autoreconf"
fi

# func_usage
# outputs to stdout the --help usage message.
func_usage ()
{
  echo "\
Usage: gnulib-tool --list
       gnulib-tool --import [module1 ... moduleN]
       gnulib-tool --update
       gnulib-tool --create-testdir --dir=directory module1 ... moduleN
       gnulib-tool --create-megatestdir --dir=directory [module1 ... moduleN]
       gnulib-tool --test --dir=directory module1 ... moduleN
       gnulib-tool --megatest --dir=directory [module1 ... moduleN]
       gnulib-tool --extract-description module
       gnulib-tool --extract-filelist module
       gnulib-tool --extract-dependencies module
       gnulib-tool --extract-autoconf-snippet module
       gnulib-tool --extract-automake-snippet module
       gnulib-tool --extract-include-directive module
       gnulib-tool --extract-license module
       gnulib-tool --extract-maintainer module
       gnulib-tool --extract-tests-module module

Operation modes:
      --list                print the available module names
      --import              import the given modules into the current package;
                            if no modules are specified, update the current
                            package from the current gnulib
      --update              update the current package, restore files omitted
                            from CVS
      --create-testdir      create a scratch package with the given modules
      --create-megatestdir  create a mega scratch package with the given modules
                            one by one and all together
      --test                test the combination of the given modules
                            (recommended to use CC=\"gcc -Wall\" here)
      --megatest            test the given modules one by one and all together
                            (recommended to use CC=\"gcc -Wall\" here)
      --extract-description        extract the description
      --extract-filelist           extract the list of files
      --extract-dependencies       extract the dependencies
      --extract-autoconf-snippet   extract the snippet for configure.ac
      --extract-automake-snippet   extract the snippet for lib/Makefile.am
      --extract-include-directive  extract the #include directive
      --extract-license            report the license terms of the source files
                                   under lib/
      --extract-maintainer         report the maintainer(s) inside gnulib
      --extract-tests-module       report the unit test module, if it exists

Options:
      --assume-autoconf=VERSION
                            Assume a given autoconf version (or newer).
                            If VERSION is 'latest-stable', assume the latest
                            stable version.
      --avoid=MODULE        Avoid including the given MODULE. Useful if you
                            have code that provides equivalent functionality.
                            This option can be repeated.
      --dry-run             For --import, only print what would have been done.
      --lgpl                Abort if modules aren't available under the LGPL.
                            Also modify license template from GPL to LGPL.
      --lib=LIBRARY         Specify the library name.  Defaults to 'libgnu'.
      --libtool             Use libtool rules, for --import.
      --macro-prefix=PREFIX  Specify the prefix of the macros gl_EARLY and
                             gl_INIT. Default is "gl".
      --no-changelog        don't update or create ChangeLog files
  -s, --symbolic, --symlink Make symbolic links instead of copying files.
      --with-tests          Include unit tests for the included modules.

Directory options:
      --dir=DIRECTORY       specify the target directory
                            For --import, this specifies where your
                            configure.ac can be found.  Defaults to current
                            directory.
      --aux-dir=DIRECTORY   Directory relative to --dir where auxiliary build
                            tools are placed (default \"build-aux\").
      --doc-base=DIRECTORY  Directory relative to --dir where doc files are
                            placed (default \"doc\"), for --import.
      --m4-base=DIRECTORY   Directory relative to --dir where *.m4 macros are
                            placed (default \"m4\"), for --import.
      --source-base=DIRECTORY  Directory relative to --dir where source code is
                               placed (default \"lib\"), for --import.
      --tests-base=DIRECTORY   Directory relative to --dir where unit tests are
                               placed (default \"tests\"), for --import.

Report bugs to <bug-gnulib@gnu.org>."
}

# func_version
# outputs to stdout the --version message.
func_version ()
{
  year=`echo "$last_checkin_date" | sed -e 's,/.*$,,'`
  echo "$progname (GNU $package) $version"
  echo "Copyright (C) $year Free Software Foundation, Inc.
This is free software; see the source for copying conditions.  There is NO
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
  echo "Written by" "Bruno Haible" "and" "Simon Josefsson"
}

# func_emit_copyright_notice
# outputs to stdout a header for a generated file.
func_emit_copyright_notice ()
{
  echo "# Copyright (C) 2004-2006 Free Software Foundation, Inc."
  echo "#"
  echo "# This file is free software, distributed under the terms of the GNU"
  echo "# General Public License.  As a special exception to the GNU General"
  echo "# Public License, this file may be distributed as part of a program"
  echo "# that contains a configuration script generated by Autoconf, under"
  echo "# the same distribution terms as the rest of that program."
  echo "#"
  echo "# Generated by gnulib-tool."
}

# func_tmpdir
# creates a temporary directory.
# Sets variable
# - tmp             pathname of freshly created temporary directory
func_tmpdir ()
{
  # Use the environment variable TMPDIR, falling back to /tmp. This allows
  # users to specify a different temporary directory, for example, if their
  # /tmp is filled up or too small.
  : ${TMPDIR=/tmp}
  {
    # Use the mktemp program if available. If not available, hide the error
    # message.
    tmp=`(umask 077 && mktemp -d "$TMPDIR/glXXXXXX") 2>/dev/null` &&
    test -n "$tmp" && test -d "$tmp"
  } ||
  {
    # Use a simple mkdir command. It is guaranteed to fail if the directory
    # already exists.  $RANDOM is bash specific and expands to empty in shells
    # other than bash, ksh and zsh.  Its use does not increase security;
    # rather, it minimizes the probability of failure in a very cluttered /tmp
    # directory.
    tmp=$TMPDIR/gl$$-$RANDOM
    (umask 077 && mkdir "$tmp")
  } ||
  {
    echo "$0: cannot create a temporary directory in $TMPDIR" >&2
    { (exit 1); exit 1; }
  }
}

# func_fatal_error message
# outputs to stderr a fatal error message, and terminates the program.
func_fatal_error ()
{
  echo "gnulib-tool: *** $1" 1>&2
  echo "gnulib-tool: *** Stop." 1>&2
  exit 1
}

# func_readlink SYMLINK
# outputs the target of the given symlink.
if (type -p readlink) > /dev/null 2>&1; then
  func_readlink ()
  {
    # Use the readlink program from GNU coreutils.
    readlink "$1"
  }
else
  func_readlink ()
  {
    # Use two sed invocations. A single sed -n -e 's,^.* -> \(.*\)$,\1,p'
    # would do the wrong thing if the link target contains " -> ".
    LC_ALL=C ls -l "$1" | sed -e 's, -> ,#%%#,' | sed -n -e 's,^.*#%%#\(.*\)$,\1,p'
  }
fi

# func_ln_if_changed SRC DEST
# Like ln -s, but avoids munging timestamps if the link is correct.
func_ln_if_changed ()
{
  if test $# -ne 2; then
    echo "usage: func_ln_if_changed SRC DEST" >&2
  fi
  if test -L "$2" && test "$1" = "`func_readlink "$2"`"; then
    :
  else
    rm -f "$2"
    ln -s "$1" "$2"
  fi
}

# Command-line option processing.
# Removes the OPTIONS from the arguments. Sets the variables:
# - mode            list or import or create-testdir or create-megatestdir
# - destdir         from --dir
# - libname, supplied_libname  from --lib
# - sourcebase      from --source-base
# - m4base          from --m4-base
# - docbase         from --doc-base
# - testsbase       from --tests-base
# - auxdir          from --aux-dir
# - inctests        true if --with-tests was given, blank otherwise
# - avoidlist       list of modules to avoid, from --avoid
# - lgpl            true if --lgpl was given, blank otherwise
# - libtool         true if --libtool was given, blank otherwise
# - macro_prefix    from --macro-prefix
# - autoconf_minversion  minimum supported autoconf version
# - do_changelog    false if --no-changelog was given, : otherwise
# - doit            : if actions shall be executed, false if only to be printed
{
  mode=
  destdir=
  libname=libgnu
  supplied_libname=
  sourcebase=
  m4base=
  docbase=
  testsbase=
  auxdir=
  inctests=
  avoidlist=
  lgpl=
  libtool=
  macro_prefix=
  autoconf_minversion=
  do_changelog=:
  doit=:
  symbolic=

  supplied_opts="$@"

  while test $# -gt 0; do
    case "$1" in
      --list | --lis )
        mode=list
        shift ;;
      --import | --impor | --impo | --imp | --im | --i )
        mode=import
        shift ;;
      --update | --updat | --upda | --upd | --up | --u )
        mode=update
        shift ;;
      --create-testdir | --create-testdi | --create-testd | --create-test | --create-tes | --create-te | --create-t )
        mode=create-testdir
        shift ;;
      --create-megatestdir | --create-megatestdi | --create-megatestd | --create-megatest | --create-megates | --create-megate | --create-megat | --create-mega | --create-meg | --create-me | --create-m )
        mode=create-megatestdir
        shift ;;
      --test | --tes | --te | --t )
        mode=test
        shift ;;
      --megatest | --megates | --megate | --megat | --mega | --meg | --me | --m )
        mode=megatest
        shift ;;
      --extract-* )
        mode=`echo "X$1" | sed -e 's/^X--//'`
        shift ;;
      --dir )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --dir"
        fi
        destdir=$1
        shift ;;
      --dir=* )
        destdir=`echo "X$1" | sed -e 's/^X--dir=//'`
        shift ;;
      --lib )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --lib"
        fi
        libname=$1
        supplied_libname=true
        shift ;;
      --lib=* )
        libname=`echo "X$1" | sed -e 's/^X--lib=//'`
        supplied_libname=true
        shift ;;
      --source-base )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --source-base"
        fi
        sourcebase=$1
        shift ;;
      --source-base=* )
        sourcebase=`echo "X$1" | sed -e 's/^X--source-base=//'`
        shift ;;
      --m4-base )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --m4-base"
        fi
        m4base=$1
        shift ;;
      --m4-base=* )
        m4base=`echo "X$1" | sed -e 's/^X--m4-base=//'`
        shift ;;
      --doc-base )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --doc-base"
        fi
        docbase=$1
        shift ;;
      --doc-base=* )
        docbase=`echo "X$1" | sed -e 's/^X--doc-base=//'`
        shift ;;
      --tests-base )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --tests-base"
        fi
        testsbase=$1
        shift ;;
      --tests-base=* )
        testsbase=`echo "X$1" | sed -e 's/^X--tests-base=//'`
        shift ;;
      --aux-dir )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --aux-dir"
        fi
        auxdir=$1
        shift ;;
      --aux-dir=* )
        auxdir=`echo "X$1" | sed -e 's/^X--aux-dir=//'`
        shift ;;
      --with-tests )
        inctests=true
        shift ;;
      --avoid )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --avoid"
        fi
        avoidlist="$avoidlist $1"
        shift ;;
      --avoid=* )
        avoidlist="$avoidlist "`echo "X$1" | sed -e 's/^X--avoid=//'`
        shift ;;
      --lgpl )
        lgpl=true
        shift ;;
      --libtool )
        libtool=true
        shift ;;
      --macro-prefix )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --macro-prefix"
        fi
        macro_prefix="$1"
        shift ;;
      --macro-prefix=* )
        macro_prefix=`echo "X$1" | sed -e 's/^X--macro-prefix=//'`
        shift ;;
      --assume-autoconf )
        shift
        if test $# = 0; then
          func_fatal_error "missing argument for --assume-autoconf"
        fi
        autoconf_minversion="$1"
        shift ;;
      --assume-autoconf=* )
        autoconf_minversion=`echo "X$1" | sed -e 's/^X--assume-autoconf=//'`
        shift ;;
      --no-changelog | --no-changelo | --no-changel | --no-change | --no-chang | --no-chan | --no-cha | --no-ch | --no-c )
        do_changelog=false
        shift ;;
      --dry-run )
        doit=false
        shift ;;
      -s | --symbolic | --symboli | --symbol | --symbo | --symb | --symlink | --symlin | --symli | --syml | --sym | --sy )
        symbolic=true
        shift ;;
      --help | --hel | --he | --h )
        func_usage
        exit 0 ;;
      --version | --versio | --versi | --vers | --ver | --ve | --v )
        func_version
        exit 0 ;;
      -- )
        # Stop option processing
        shift
        break ;;
      -* )
        echo "gnulib-tool: unknown option $1" 1>&2
        echo "Try 'gnulib-tool --help' for more information." 1>&2
        exit 1 ;;
      * )
        break ;;
    esac
  done

  if test "$mode" = update; then
    if test $# != 0; then
      echo "gnulib-tool: too many arguments in 'update' mode" 1>&2
      echo "Try 'gnulib-tool --help' for more information." 1>&2
      echo "If you really want to modify the gnulib configuration of your project," 1>&2
      echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
      exit 1
    fi
    if test -n "$supplied_libname" || test -n "$sourcebase" || test -n "$m4base" \
       || test -n "$docbase" || test -n "$testsbase" || test -n "$auxdir" \
       || test -n "$inctests" || test -n "$avoidlist" || test -n "$lgpl" \
       || test -n "$macro_prefix" || test -n "$autoconf_minversion"; then
      echo "gnulib-tool: invalid options for 'update' mode" 1>&2
      echo "Try 'gnulib-tool --help' for more information." 1>&2
      echo "If you really want to modify the gnulib configuration of your project," 1>&2
      echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
      exit 1
    fi
    do_changelog=false
  fi

  DEFAULT_AUTOCONF_MINVERSION="2.59"
  case "$autoconf_minversion" in
    1.* | 2.[0-4]* | 2.5[0-8]*)
      func_fatal_error "minimum supported autoconf version is 2.59" ;;
  esac

  # Remove trailing slashes from the directory names. This is necessary for
  # m4base (to avoid an error in func_import) and optional for the others.
  sed_trimtrailingslashes='s,\([^/]\)//*$,\1,'
  case "$sourcebase" in
    */ ) sourcebase=`echo "$sourcebase" | sed -e "$sed_trimtrailingslashes"` ;;
  esac
  case "$m4base" in
    */ ) m4base=`echo "$m4base" | sed -e "$sed_trimtrailingslashes"` ;;
  esac
  case "$docbase" in
    */ ) docbase=`echo "$docbase" | sed -e "$sed_trimtrailingslashes"` ;;
  esac
  case "$testsbase" in
    */ ) testsbase=`echo "$testsbase" | sed -e "$sed_trimtrailingslashes"` ;;
  esac
  case "$auxdir" in
    */ ) auxdir=`echo "$auxdir" | sed -e "$sed_trimtrailingslashes"` ;;
  esac
}

case "$0" in
  /*) self_abspathname="$0" ;;
  */*) self_abspathname=`pwd`/"$0" ;;
  *) for d in `echo ":$PATH:" | sed -e 's/:::*/:.:/g' | sed -e 's/:/ /g'`; do
       if test -x "$d/$0" && test ! -d "$d/$0"; then
         self_abspathname="$d/$0"
         break
       fi
     done
     if test -z "$self_abspathname"; then
       func_fatal_error "could not locate the gnulib-tool program - how did you invoke it?"
     fi
     ;;
esac
while test -h "$self_abspathname"; do
  # Resolve symbolic link.
  linkval=`func_readlink "$self_abspathname"`
  test -n "$linkval" || break
  case "$linkval" in
    /* ) self_abspathname="$linkval" ;;
    * ) self_abspathname=`echo "$self_abspathname" | sed -e 's,/[^/]*$,,'`/"$linkval" ;;
  esac
done
gnulib_dir=`echo "$self_abspathname" | sed -e 's,/[^/]*$,,'`

# func_all_modules
func_all_modules ()
{
  # Filter out metainformation files like README, which are not modules.
  # Filter out unit test modules; they can be retrieved through
  # --extract-tests-module if desired.
  (cd "$gnulib_dir/modules" && ls -1) \
      | sed -e '/^CVS$/d' -e '/^ChangeLog$/d' -e '/^README$/d' -e '/^TEMPLATE$/d' -e '/^TEMPLATE-TESTS$/d' -e '/~$/d' \
      | sed -e '/-tests$/d' \
      | LC_ALL=C sort
}

# func_verify_module
# verifies a module name
func_verify_module ()
{
  if test ! -f "$gnulib_dir/modules/$module" \
     || test "CVS" = "$module" \
     || test "ChangeLog" = "$module" \
     || test "README" = "$module" \
     || test "TEMPLATE" = "$module" \
     || test "TEMPLATE-TESTS" = "$module"; then
    echo "gnulib-tool: module $module doesn't exist" 1>&2
    module=
  fi
}

# func_verify_nontests_module
# verifies a module name, excluding tests modules
func_verify_nontests_module ()
{
  case "$module" in
    *-tests ) module= ;;
    * ) func_verify_module ;;
  esac
}

# func_verify_tests_module
# verifies a module name, considering only tests modules
func_verify_tests_module ()
{
  case "$module" in
    *-tests ) func_verify_module ;;
    * ) module= ;;
  esac
}

sed_extract_prog=':[	 ]*$/ {
  :a
    n
    s/^Description:[	 ]*$//
    s/^Files:[	 ]*$//
    s/^Depends-on:[	 ]*$//
    s/^configure\.ac:[	 ]*$//
    s/^Makefile\.am:[	 ]*$//
    s/^Include:[	 ]*$//
    s/^License:[	 ]*$//
    s/^Maintainer:[	 ]*$//
    tb
    p
    ba
  :b
}'

# func_get_description module
func_get_description ()
{
  sed -n -e "/^Description$sed_extract_prog" < "$gnulib_dir/modules/$1"
}

# func_get_filelist module
func_get_filelist ()
{
  sed -n -e "/^Files$sed_extract_prog" < "$gnulib_dir/modules/$1"
  case "$autoconf_minversion" in
    2.59)
      #echo m4/onceonly.m4
      echo m4/onceonly_2_57.m4
      ;;
  esac
}

# func_get_dependencies module
func_get_dependencies ()
{
  # ${module}-tests always implicitly depends on ${module}.
  echo "$1" | sed -n -e 's/-tests//p'
  # Then the explicit dependencies listed in the module description.
  sed -n -e "/^Depends-on$sed_extract_prog" < "$gnulib_dir/modules/$1"
}

# func_get_autoconf_snippet module
func_get_autoconf_snippet ()
{
  sed -n -e "/^configure\.ac$sed_extract_prog" < "$gnulib_dir/modules/$1"
}

# func_get_automake_snippet module
func_get_automake_snippet ()
{
  sed -n -e "/^Makefile\.am$sed_extract_prog" < "$gnulib_dir/modules/$1"
}

# func_get_include_directive module
func_get_include_directive ()
{
  sed -n -e "/^Include$sed_extract_prog" < "$gnulib_dir/modules/$1" | \
  sed -e 's/^\(["<]\)/#include \1/'
}

# func_get_license module
func_get_license ()
{
  sed -n -e "/^License$sed_extract_prog" < "$gnulib_dir/modules/$1"
}

# func_get_maintainer module
func_get_maintainer ()
{
  sed -n -e "/^Maintainer$sed_extract_prog" < "$gnulib_dir/modules/$1"
}

# func_get_tests_module module
func_get_tests_module ()
{
  # The naming convention for tests modules is hardwired: ${module}-tests.
  if test -f modules/"$1"-tests; then
    echo "$1"-tests
  fi
}

# func_acceptable module
# tests whether a module is acceptable.
# Input:
# - avoidlist       list of modules to avoid
func_acceptable ()
{
  for avoid in $avoidlist; do
    if test "$avoid" = "$1"; then
      return 1
    fi
  done
  return 0
}

# func_modules_transitive_closure
# Input:
# - modules         list of specified modules
# - inctests        true if tests should be included, blank otherwise
# - avoidlist       list of modules to avoid
# Output:
# - modules         list of modules, including dependencies
func_modules_transitive_closure ()
{
  while true; do
    xmodules=
    for module in $modules; do
      func_verify_module
      if test -n "$module"; then
        # Duplicate dependencies are harmless, but Jim wants a warning.
        duplicated_deps=`func_get_dependencies $module | LC_ALL=C sort | LC_ALL=C uniq -d`
        if test -n "$duplicated_deps"; then
          echo "warning: module $module has duplicated dependencies: "`echo $duplicated_deps` 1>&2
        fi
        if func_acceptable $module; then
          xmodules="$xmodules $module"
          for depmodule in `func_get_dependencies $module`; do
            if func_acceptable $depmodule; then
              xmodules="$xmodules $depmodule"
            fi
          done
          if test -n "$inctests"; then
            testsmodule=`func_get_tests_module $module`
            if test -n "$testsmodule"; then
              if func_acceptable $testsmodule; then
                xmodules="$xmodules $testsmodule"
                for depmodule in `func_get_dependencies $testsmodule`; do
                  if func_acceptable $depmodule; then
                    xmodules="$xmodules $depmodule"
                  fi
                done
              fi
            fi
          fi
        fi
      fi
    done
    xmodules=`for m in $xmodules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
    if test "$xmodules" = "$modules"; then
      break
    fi
    modules="$xmodules"
  done
}

# func_modules_add_dummy
# Input:
# - modules         list of modules, including dependencies
# Output:
# - modules         list of modules, including 'dummy' if needed
func_modules_add_dummy ()
{
  have_lib_SOURCES=
  sed_remove_backslash_newline=':a
/\\$/{
s/\\$//
N
s/\n//
ba
}'
  for module in $modules; do
    func_verify_nontests_module
    if test -n "$module"; then
      # Extract the value of "lib_SOURCES += ...".
      for file in `func_get_automake_snippet "$module" | sed -e "$sed_remove_backslash_newline" | sed -n -e 's,^lib_SOURCES[	 ]*+=\([^#]*\).*$,\1,p'`; do
        # Ignore .h files since they are not compiled.
        case "$file" in
          *.h) ;;
          *) have_lib_SOURCES=yes ;;
        esac
      done
    fi
  done
  # Add the dummy module, to make sure the library will be non-empty.
  if test -z "$have_lib_SOURCES"; then
    modules="$modules dummy"
  fi
}

# func_modules_to_filelist
# Input:
# - modules         list of modules, including dependencies
# Output:
# - files           list of files
func_modules_to_filelist ()
{
  files=
  for module in $modules; do
    func_verify_module
    if test -n "$module"; then
      files="$files "`func_get_filelist $module`
    fi
  done
  files=`for f in $files; do echo $f; done | LC_ALL=C sort | LC_ALL=C uniq`
}

# func_emit_lib_Makefile_am
# emits the contents of lib/Makefile.am to standard output.
# Input:
# - modules         list of modules, including dependencies
# - libname         library name
# - libtool         true if libtool will be used, blank otherwise
# - actioncmd       (optional) command that will reproduce this invocation
func_emit_lib_Makefile_am ()
{
  if test -n "$libtool"; then
    libext=la
    perhapsLT=LT
  else
    libext=a
    perhapsLT=
  fi
  echo "## Process this file with automake to produce Makefile.in."
  func_emit_copyright_notice
  if test -n "$actioncmd"; then
    echo "# Reproduce by: $actioncmd"
  fi
  echo
  # No need to generate dependencies since the sources are in gnulib, not here.
  echo "AUTOMAKE_OPTIONS = 1.5 gnits no-dependencies"
  echo
  echo "noinst_${perhapsLT}LIBRARIES = $libname.$libext"
  echo
  echo "${libname}_${libext}_SOURCES ="
  echo "${libname}_${libext}_LIBADD = @${perhapsLT}LIBOBJS@"
  echo "noinst_HEADERS ="
  echo "EXTRA_DIST ="
  echo "BUILT_SOURCES ="
  echo "SUFFIXES ="
  echo "MOSTLYCLEANFILES ="
  echo "MOSTLYCLEANDIRS ="
  echo "CLEANFILES ="
  echo "DISTCLEANFILES ="
  echo "MAINTAINERCLEANFILES ="
  echo
  echo "AM_CPPFLAGS ="
  echo
  for module in $modules; do
    func_verify_nontests_module
    if test -n "$module"; then
      {
        func_get_automake_snippet "$module" |
          sed -e 's,lib_\([A-Z][A-Z]*\),'"${libname}_${libext}"'_\1,g'
        if test "$module" = 'alloca'; then
          echo "${libname}_${libext}_LIBADD += @${perhapsLT}ALLOCA@"
        fi
      } > amsnippet.tmp
      # Skip the contents if its entirely empty.
      if grep '[^	 ]' amsnippet.tmp > /dev/null ; then
        echo "## begin gnulib module $module"
        echo
        cat amsnippet.tmp
        echo "## end   gnulib module $module"
        echo
      fi
      rm -f amsnippet.tmp
    fi
  done
  echo
  echo "mostlyclean-local:"
  echo "	@test -z \"\$(MOSTLYCLEANDIRS)\" || \\"
  echo "	  for dir in \$(MOSTLYCLEANDIRS); do \\"
  echo "	    if test -d \$\$dir; then \\"
  echo "	      echo \"rmdir \$\$dir\"; rmdir \$\$dir; \\"
  echo "	    fi; \\"
  echo "	  done"
  echo
  echo "# Makefile.am ends here"
}

# func_emit_tests_Makefile_am
# emits the contents of tests/Makefile.am to standard output.
# Input:
# - modules         list of modules, including dependencies
# - libname         library name
# - libtool         true if libtool will be used, blank otherwise
# - sourcebase      relative directory containing lib source code
# - m4base          relative directory containing autoconf macros
# - testsbase       relative directory containing unit test code
func_emit_tests_Makefile_am ()
{
  if test -n "$libtool"; then
    libext=la
  else
    libext=a
  fi
  testsbase_inverse=`echo "$testsbase" | sed -e 's,/$,,' | sed -e 's,[^/][^/]*,..,g'`
  echo "## Process this file with automake to produce Makefile.in."
  func_emit_copyright_notice
  echo
  # Generate dependencies here, since it eases the debugging of test failures.
  echo "AUTOMAKE_OPTIONS = 1.5 foreign"
  echo
  echo "ACLOCAL_AMFLAGS = -I ${testsbase_inverse}/${m4base}"
  echo
  # Nothing is being added to SUBDIRS; nevertheless the existence of this
  # variable is needed to avoid an error from automake:
  #   "AM_GNU_GETTEXT used but SUBDIRS not defined"
  echo "SUBDIRS ="
  echo "TESTS ="
  echo "TESTS_ENVIRONMENT ="
  echo "noinst_PROGRAMS ="
  echo "check_PROGRAMS ="
  echo "noinst_HEADERS ="
  echo "EXTRA_DIST ="
  echo "BUILT_SOURCES ="
  echo "SUFFIXES ="
  echo "MOSTLYCLEANFILES ="
  echo "MOSTLYCLEANDIRS ="
  echo "CLEANFILES ="
  echo "DISTCLEANFILES ="
  echo "MAINTAINERCLEANFILES ="
  echo
  echo "AM_CPPFLAGS = \\"
  echo "  -I. -I\$(srcdir) \\"
  echo "  -I${testsbase_inverse} -I\$(srcdir)/${testsbase_inverse} \\"
  echo "  -I${testsbase_inverse}/${sourcebase-lib} -I\$(srcdir)/${testsbase_inverse}/${sourcebase-lib}"
  echo
  echo "LDADD = ${testsbase_inverse}/${sourcebase-lib}/${libname}.${libext}"
  echo
  for module in $modules; do
    func_verify_tests_module
    if test -n "$module"; then
      func_get_automake_snippet "$module" > amsnippet.tmp
      # Skip the contents if its entirely empty.
      if grep '[^	 ]' amsnippet.tmp > /dev/null ; then
        echo "## begin gnulib module $module"
        echo
        cat amsnippet.tmp
        echo "## end   gnulib module $module"
        echo
      fi
      rm -f amsnippet.tmp
    fi
  done
  echo "# Clean up after Solaris cc."
  echo "clean-local:"
  echo "	rm -rf SunWS_cache"
  echo
  echo "mostlyclean-local:"
  echo "	@test -z \"\$(MOSTLYCLEANDIRS)\" || \\"
  echo "	  for dir in \$(MOSTLYCLEANDIRS); do \\"
  echo "	    if test -d \$\$dir; then \\"
  echo "	      echo \"rmdir \$\$dir\"; rmdir \$\$dir; \\"
  echo "	    fi; \\"
  echo "	  done"
  echo
  echo "# Makefile.am ends here"
}

# func_import modules
# Uses also the variables
# - destdir         target directory
# - libname         library name
# - sourcebase      directory relative to destdir where to place source code
# - m4base          directory relative to destdir where to place *.m4 macros
# - docbase         directory relative to destdir where to place doc files
# - testsbase       directory relative to destdir where to place unit test code
# - auxdir          directory relative to destdir where to place build aux files
# - inctests        true if --with-tests was given, blank otherwise
# - avoidlist       list of modules to avoid, from --avoid
# - lgpl            true if library's license shall be LGPL, blank otherwise
# - libtool         true if libtool will be used, blank otherwise
# - guessed_libtool true if the configure.ac file uses libtool, blank otherwise
# - macro_prefix    prefix of gl_EARLY, gl_INIT macros to use
# - autoconf_minversion  minimum supported autoconf version
# - doit            : if actions shall be executed, false if only to be printed
# - symbolic        true if files should be symlinked, copied otherwise
func_import ()
{
  # Get the cached settings.
  cached_specified_modules=
  cached_avoidlist=
  cached_sourcebase=
  cached_m4base=
  cached_docbase=
  cached_testsbase=
  cached_libname=
  cached_lgpl=
  cached_libtool=
  cached_macro_prefix=
  cached_autoconf_minversion=
  cached_files=
  if test -f "$destdir"/$m4base/gnulib-cache.m4; then
    my_sed_traces='
      s,#.*$,,
      s,^dnl .*$,,
      s, dnl .*$,,
      /gl_MODULES(/ {
        s,^.*gl_MODULES([[ ]*\([^])]*\).*$,cached_specified_modules="\1",p
      }
      /gl_AVOID(/ {
        s,^.*gl_AVOID([[ ]*\([^])]*\).*$,cached_avoidlist="\1",p
      }
      /gl_SOURCE_BASE(/ {
        s,^.*gl_SOURCE_BASE([[ ]*\([^])]*\).*$,cached_sourcebase="\1",p
      }
      /gl_M4_BASE(/ {
        s,^.*gl_M4_BASE([[ ]*\([^])]*\).*$,cached_m4base="\1",p
      }
      /gl_DOC_BASE(/ {
        s,^.*gl_DOC_BASE([[ ]*\([^])]*\).*$,cached_docbase="\1",p
      }
      /gl_TESTS_BASE(/ {
        s,^.*gl_TESTS_BASE([[ ]*\([^])]*\).*$,cached_testsbase="\1",p
      }
      /gl_LIB(/ {
        s,^.*gl_LIB([[ ]*\([^])]*\).*$,cached_libname="\1",p
      }
      /gl_LGPL/ {
        s,^.*$,cached_lgpl=true,p
      }
      /gl_LIBTOOL/ {
        s,^.*$,cached_libtool=true,p
      }
      /gl_MACRO_PREFIX(/ {
        s,^.*gl_MACRO_PREFIX([[ ]*\([^])]*\).*$,cached_macro_prefix="\1",p
      }
      /gl_AUTOCONF_MINVERSION(/ {
        s,^.*gl_AUTOCONF_MINVERSION([[ ]*\([^])]*\).*$,cached_autoconf_minversion="\1",p
      }'
    eval `sed -n -e "$my_sed_traces" < "$destdir"/$m4base/gnulib-cache.m4`
    if test -f "$destdir"/$m4base/gnulib-comp.m4; then
      my_sed_traces='
        s,#.*$,,
        s,^dnl .*$,,
        s, dnl .*$,,
        /AC_DEFUN(\['"${cached_macro_prefix}"'_FILE_LIST\], \[/ {
          s,^.*$,cached_files=",p
          n
          ta
          :a
          s,^\]).*$,",
          tb
          p
          n
          ba
          :b
          p
        }'
      eval `sed -n -e "$my_sed_traces" < "$destdir"/$m4base/gnulib-comp.m4`
    fi
  fi

  # Merge the cached settings with the specified ones.
  # The m4base must be the same as expected from the pathname.
  if test -n "$cached_m4base" && test "$cached_m4base" != "$m4base"; then
    func_fatal_error "$m4base/gnulib-cache.m4 is expected to contain gl_M4_BASE([$m4base])"
  fi
  # Append the cached and the specified module names. So that
  # "gnulib-tool --import foo" means to add the module foo.
  specified_modules="$cached_specified_modules $1"
  # Append the cached and the specified avoidlist. This is probably better
  # than dropping the cached one when --avoid is specified at least once.
  avoidlist=`echo $cached_avoidlist $avoidlist`
  # The sourcebase defaults to the cached one.
  if test -z "$sourcebase"; then
    sourcebase="$cached_sourcebase"
    if test -z "$sourcebase"; then
      func_fatal_error "missing --source-base option"
    fi
  fi
  # The docbase defaults to the cached one.
  if test -z "$docbase"; then
    docbase="$cached_docbase"
    if test -z "$docbase"; then
      func_fatal_error "missing --doc-base option"
    fi
  fi
  # The testsbase defaults to the cached one.
  if test -z "$testsbase"; then
    testsbase="$cached_testsbase"
    if test -z "$testsbase"; then
      func_fatal_error "missing --tests-base option"
    fi
  fi
  # The libname defaults to the cached one.
  if test -z "$supplied_libname"; then
    libname="$cached_libname"
    if test -z "$libname"; then
      func_fatal_error "missing --lib option"
    fi
  fi
  # Require LGPL if specified either way.
  if test -z "$lgpl"; then
    lgpl="$cached_lgpl"
  fi
  # Use libtool if specified either way, or if guessed.
  if test -z "$libtool"; then
    if test -n "$cached_m4base"; then
      libtool="$cached_libtool"
    else
      libtool="$guessed_libtool"
    fi
  fi
  # The macro_prefix defaults to the cached one.
  if test -z "$macro_prefix"; then
    macro_prefix="$cached_macro_prefix"
    if test -z "$macro_prefix"; then
      func_fatal_error "missing --macro-prefix option"
    fi
  fi
  # The autoconf_minversion defaults to the cached one.
  if test -z "$autoconf_minversion"; then
    autoconf_minversion="$cached_autoconf_minversion"
    if test -z "$autoconf_minversion"; then
      autoconf_minversion="$DEFAULT_AUTOCONF_MINVERSION"
    fi
  fi

  # Canonicalize the list of specified modules.
  specified_modules=`for m in $specified_modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`

  # Determine final module list.
  modules="$specified_modules"
  func_modules_transitive_closure
  echo "Module list with included dependencies:"
  echo "$modules" | sed -e 's/^/  /'

  # Add the dummy module if needed.
  func_modules_add_dummy

  # If --lgpl, check the license of modules are compatible.
  if test -n "$lgpl"; then
    for module in $modules; do
      license=`func_get_license $module`
      case $license in
        LGPL | 'GPLed build tool' | 'public domain' | 'unlimited') ;;
        *) func_fatal_error "incompatible license on module $module: $license" ;;
      esac
    done
  fi

  # Determine final file list.
  func_modules_to_filelist
  echo "File list:"
  echo "$files" | sed -e 's/^/  /'

  test -n "$files" \
    || func_fatal_error "refusing to do nothing"

  # Add m4/gnulib-tool.m4 to the file list. It is not part of any module.
  new_files="$files m4/gnulib-tool.m4"
  old_files="$cached_files"
  if test -f "$destdir"/$m4base/gnulib-tool.m4; then
    old_files="$old_files m4/gnulib-tool.m4"
  fi

  # Create directories.
  if test ! -d "$destdir/$sourcebase"; then
    if $doit; then
      echo "Creating directory $destdir/$sourcebase"
      mkdir "$destdir/$sourcebase" || func_fatal_error "failed"
    else
      echo "Create directory $destdir/$sourcebase"
    fi
  fi
  if test ! -d "$destdir/$m4base"; then
    if $doit; then
      echo "Creating directory $destdir/$m4base"
      mkdir "$destdir/$m4base" || func_fatal_error "failed"
    else
      echo "Create directory $destdir/$m4base"
    fi
  fi
  if test ! -d "$destdir/$docbase"; then
    if $doit; then
      echo "Creating directory $destdir/$docbase"
      mkdir "$destdir/$docbase" || func_fatal_error "failed"
    else
      echo "Create directory $destdir/$docbase"
    fi
  fi
  if test -n "$inctests"; then
    if test ! -d "$destdir/$testsbase"; then
      if $doit; then
        echo "Creating directory $destdir/$testsbase"
        mkdir "$destdir/$testsbase" || func_fatal_error "failed"
      else
        echo "Create directory $destdir/$testsbase"
      fi
    fi
  fi
  if test ! -d "$destdir/$auxdir"; then
    if $doit; then
      echo "Creating directory $destdir/$auxdir"
      mkdir "$destdir/$auxdir" || func_fatal_error "failed"
    else
      echo "Create directory $destdir/$auxdir"
    fi
  fi

  func_tmpdir
  trap 'rm -rf "$tmp"' 0 1 2 3 15
  # func_dest_tmpfilename file
  # determines the name of a temporary file (file is relative to destdir).
  # Sets variable:
  #   - tmpfile       absolute filename of the temporary file
  func_dest_tmpfilename ()
  {
    if $doit; then
      # Put the new contents of $file in a file in the same directory (needed
      # to guarantee that an 'mv' to "$destdir/$file" works).
      tmpfile="$destdir/$1.tmp"
    else
      # Put the new contents of $file in a file in a temporary directory
      # (because the directory of "$file" might not exist).
      tmpfile="$tmp"/`basename "$1"`.tmp
    fi
  }

  # Copy files or make symbolic links. Remove obsolete files.
  delimiter='	'
  for f in $old_files; do
    case "$f" in
      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
      doc/*) g=`echo "$f" | sed -e "s,^doc/,$cached_docbase/,"` ;;
      lib/*) g=`echo "$f" | sed -e "s,^lib/,$cached_sourcebase/,"` ;;
      m4/*) g=`echo "$f" | sed -e "s,^m4/,$cached_m4base/,"` ;;
      tests/*) g=`echo "$f" | sed -e "s,^tests/,$cached_testsbase/,"` ;;
      *) g="$f" ;;
    esac
    echo "$g""$delimiter""$f"
  done | LC_ALL=C sort > "$tmp"/old-files
  for f in $new_files; do
    case "$f" in
      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
      *) g="$f" ;;
    esac
    echo "$g""$delimiter""$f"
  done | LC_ALL=C sort > "$tmp"/new-files
  # First the files that are in old-files, but not in new-files:
  sed_take_first_column='s,'"$delimiter"'.*,,'
  for g in `LC_ALL=C join -t"$delimiter" -v1 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_first_column"`; do
    # Remove the file. Do nothing if the user already removed it.
    if test -f "$destdir/$g"; then
      if $doit; then
        echo "Removing file $g (backup in ${g}~)"
        mv -f "$destdir/$g" "$destdir/${g}~" || func_fatal_error "failed"
      else
        echo "Remove file $g (backup in ${g}~)"
      fi
    fi
  done
  # func_add_or_update handles a file that ought to be present afterwards.
  # Uses parameters f, g, already_present.
  func_add_or_update ()
  {
    func_dest_tmpfilename "$g"
    cp "$gnulib_dir/$f" "$tmpfile" || func_fatal_error "failed"
    if test -n "$lgpl"; then
      # Update license.
      case "$f" in
        lib/*)
          sed -e 's/GNU General/GNU Lesser General/g' \
              -e 's/version 2\([ ,]\)/version 2.1\1/g' \
            < "$gnulib_dir/$f" > "$tmpfile" || func_fatal_error "failed"
          ;;
      esac
    fi
    if test -f "$destdir/$g"; then
      # The file already exists.
      if cmp "$destdir/$g" "$tmpfile" > /dev/null; then
        : # The file has not changed.
      else
        # Replace the file.
        if $doit; then
          if test -n "$already_present"; then
            echo "Updating file $g (backup in ${g}~)"
          else
            echo "Replacing file $g (non-gnulib code backuped in ${g}~) !!"
          fi
          mv -f "$destdir/$g" "$destdir/${g}~" || func_fatal_error "failed"
          if test -n "$symbolic" && cmp "$gnulib_dir/$f" "$tmpfile" > /dev/null; then
            func_ln_if_changed "$gnulib_dir/$f" "$destdir/$g"
          else
            mv -f "$tmpfile" "$destdir/${g}" || func_fatal_error "failed"
          fi
        else
          if test -n "$already_present"; then
            echo "Update file $g (backup in ${g}~)"
          else
            echo "Replace file $g (non-gnulib code backuped in ${g}~) !!"
          fi
        fi
      fi
    else
      # Install the file.
      # Don't protest if the file should be there but isn't: it happens
      # frequently that developers don't put autogenerated files into CVS.
      if $doit; then
        echo "Copying file $g"
        if test -n "$symbolic" && cmp "$gnulib_dir/$f" "$tmpfile" > /dev/null; then
          func_ln_if_changed "$gnulib_dir/$f" "$destdir/$g"
        else
          mv -f "$tmpfile" "$destdir/${g}" || func_fatal_error "failed"
        fi
      else
        echo "Copy file $g"
      fi
    fi
    rm -f "$tmpfile"
  }
  # Then the files that are in new-files, but not in old-files:
  sed_take_last_column='s,^.*'"$delimiter"',,'
  already_present=
  for f in `LC_ALL=C join -t"$delimiter" -v2 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
    case "$f" in
      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
      *) g="$f" ;;
    esac
    func_add_or_update
  done
  # Then the files that are in new-files and in old-files:
  already_present=true
  for f in `LC_ALL=C join -t"$delimiter" "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
    case "$f" in
      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
      doc/*) g=`echo "$f" | sed -e "s,^doc/,$docbase/,"` ;;
      lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
      m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
      *) g="$f" ;;
    esac
    func_add_or_update
  done

  # Command-line invocation printed in a comment in generated gnulib-cache.m4.
  actioncmd="gnulib-tool --import"
  actioncmd="$actioncmd --dir=$destdir"
  actioncmd="$actioncmd --lib=$libname"
  actioncmd="$actioncmd --source-base=$sourcebase"
  actioncmd="$actioncmd --m4-base=$m4base"
  actioncmd="$actioncmd --doc-base=$docbase"
  actioncmd="$actioncmd --aux-dir=$auxdir"
  for module in $avoidlist; do
    actioncmd="$actioncmd --avoid=$module"
  done
  if test -n "$lgpl"; then
    actioncmd="$actioncmd --lgpl"
  fi
  if test -n "$libtool"; then
    actioncmd="$actioncmd --libtool"
  fi
  actioncmd="$actioncmd --macro-prefix=$macro_prefix"
  actioncmd="$actioncmd --assume-autoconf=$autoconf_minversion"
  actioncmd="$actioncmd `echo $specified_modules`"

  # Create lib/Makefile.am.
  func_dest_tmpfilename $sourcebase/Makefile.am
  func_emit_lib_Makefile_am > "$tmpfile"
  if test -f "$destdir"/$sourcebase/Makefile.am; then
    if cmp "$destdir"/$sourcebase/Makefile.am "$tmpfile" > /dev/null; then
      rm -f "$tmpfile"
    else
      if $doit; then
        echo "Updating $sourcebase/Makefile.am (backup in $sourcebase/Makefile.am~)"
        mv -f "$destdir"/$sourcebase/Makefile.am "$destdir"/$sourcebase/Makefile.am~
        mv -f "$tmpfile" "$destdir"/$sourcebase/Makefile.am
      else
        echo "Update $sourcebase/Makefile.am (backup in $sourcebase/Makefile.am~)"
        rm -f "$tmpfile"
      fi
    fi
  else
    if $doit; then
      echo "Creating $sourcebase/Makefile.am"
      mv -f "$tmpfile" "$destdir"/$sourcebase/Makefile.am
    else
      echo "Create $sourcebase/Makefile.am"
      rm -f "$tmpfile"
    fi
  fi

  # Create m4/gnulib-cache.m4.
  func_dest_tmpfilename $m4base/gnulib-cache.m4
  (
    func_emit_copyright_notice
    echo "#"
    echo "# This file represents the specification of how gnulib-tool is used."
    echo "# It acts as a cache: It is written and read by gnulib-tool."
    echo "# In projects using CVS, this file is meant to be stored in CVS,"
    echo "# like the configure.ac and various Makefile.am files."
    echo
    echo
    echo "# Specification in the form of a command-line invocation:"
    echo "#   $actioncmd"
    echo
    echo "# Specification in the form of a few gnulib-tool.m4 macro invocations:"
    echo "gl_MODULES(["`echo $specified_modules`"])"
    echo "gl_AVOID([$avoidlist])"
    echo "gl_SOURCE_BASE([$sourcebase])"
    echo "gl_M4_BASE([$m4base])"
    echo "gl_DOC_BASE([$docbase])"
    echo "gl_TESTS_BASE([$testsbase])"
    echo "gl_LIB([$libname])"
    test -z "$lgpl" || echo "gl_LGPL"
    test -z "$libtool" || echo "gl_LIBTOOL"
    echo "gl_MACRO_PREFIX([$macro_prefix])"
    echo "gl_AUTOCONF_MINVERSION([$autoconf_minversion])"
  ) > "$tmpfile"
  if test -f "$destdir"/$m4base/gnulib-cache.m4; then
    if cmp "$destdir"/$m4base/gnulib-cache.m4 "$tmpfile" > /dev/null; then
      rm -f "$tmpfile"
    else
      if $doit; then
        echo "Updating $m4base/gnulib-cache.m4 (backup in $m4base/gnulib-cache.m4~)"
        mv -f "$destdir"/$m4base/gnulib-cache.m4 "$destdir"/$m4base/gnulib-cache.m4~
        mv -f "$tmpfile" "$destdir"/$m4base/gnulib-cache.m4
      else
        echo "Update $m4base/gnulib-cache.m4 (backup in $m4base/gnulib-cache.m4~)"
        if false; then
          cat "$tmpfile"
          echo
          echo "# gnulib-cache.m4 ends here"
        fi
        rm -f "$tmpfile"
      fi
    fi
  else
    if $doit; then
      echo "Creating $m4base/gnulib-cache.m4"
      mv -f "$tmpfile" "$destdir"/$m4base/gnulib-cache.m4
    else
      echo "Create $m4base/gnulib-cache.m4"
      cat "$tmpfile"
      rm -f "$tmpfile"
    fi
  fi

  # Create m4/gnulib-comp.m4.
  func_dest_tmpfilename $m4base/gnulib-comp.m4
  (
    func_emit_copyright_notice
    echo "#"
    echo "# This file represents the compiled summary of the specification in"
    echo "# gnulib-cache.m4. It lists the computed macro invocations that need"
    echo "# to be invoked from configure.ac."
    echo "# In projects using CVS, this file can be treated like other built files."
    echo
    echo
    echo "# This macro should be invoked from $configure_ac, in the section"
    echo "# \"Checks for programs\", right after AC_PROG_CC, and certainly before"
    echo "# any checks for libraries, header files, types and library functions."
    echo "AC_DEFUN([${macro_prefix}_EARLY],"
    echo "["
    echo "  AC_REQUIRE([AC_PROG_RANLIB])"
    if grep AC_GNU_SOURCE "$destdir"/$m4base/*.m4 >/dev/null 2>/dev/null; then
      echo "  AC_REQUIRE([AC_GNU_SOURCE])"
    fi
    if grep gl_USE_SYSTEM_EXTENSIONS "$destdir"/$m4base/*.m4 >/dev/null 2>/dev/null; then
      echo "  AC_REQUIRE([gl_USE_SYSTEM_EXTENSIONS])"
    fi
    if grep gl_LOCK "$destdir"/$m4base/*.m4 >/dev/null 2>/dev/null; then
      echo "  AC_REQUIRE([gl_LOCK])"
    fi
    echo "])"
    echo
    echo "# This macro should be invoked from $configure_ac, in the section"
    echo "# \"Check for header files, types and library functions\"."
    echo "AC_DEFUN([${macro_prefix}_INIT],"
    echo "["
    if test -z "$libtool"; then
      echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
    else
      echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
    fi
    if test "$auxdir" != "build-aux"; then
      sed_replace_build_aux='
        :a
        /AC_CONFIG_FILES(.*:build-aux\/.*)/{
          s|AC_CONFIG_FILES(\(.*\):build-aux/\(.*\))|AC_CONFIG_FILES(\1:'"$auxdir"'/\2)|
          ba
        }'
      sed_replace_build_aux=`echo "$sed_replace_build_aux" | sed -e 1d -e 's/^ *//'`
    else
      sed_replace_build_aux=
    fi
    for module in $modules; do
      func_verify_module
      if test -n "$module"; then
        func_get_autoconf_snippet "$module" \
          | sed -e '/^$/d;' -e 's/^/  /' \
                -e 's/AM_GNU_GETTEXT(\[external\])/dnl you must add AM_GNU_GETTEXT([external]) or similar to configure.ac./' \
                -e "$sed_replace_build_aux"
        if test "$module" = 'alloca' && test -n "$libtool"; then
          echo 'changequote(,)dnl'
          echo 'LTALLOCA=`echo "$ALLOCA" | sed '"'"'s/\.[^.]* /.lo /g;s/\.[^.]*$/.lo/'"'"'`'
          echo 'changequote([, ])dnl'
          echo 'AC_SUBST([LTALLOCA])'
        fi
      fi
    done
    echo "])"
    echo
    echo "# This macro records the list of files which have been installed by"
    echo "# gnulib-tool and may be removed by future gnulib-tool invocations."
    echo "AC_DEFUN([${macro_prefix}_FILE_LIST], ["
    echo "$files" | sed -e 's,^,  ,'
    echo "])"
  ) > "$tmpfile"
  if test -f "$destdir"/$m4base/gnulib-comp.m4; then
    if cmp "$destdir"/$m4base/gnulib-comp.m4 "$tmpfile" > /dev/null; then
      rm -f "$tmpfile"
    else
      if $doit; then
        echo "Updating $m4base/gnulib-comp.m4 (backup in $m4base/gnulib-comp.m4~)"
        mv -f "$destdir"/$m4base/gnulib-comp.m4 "$destdir"/$m4base/gnulib-comp.m4~
        mv -f "$tmpfile" "$destdir"/$m4base/gnulib-comp.m4
      else
        echo "Update $m4base/gnulib-comp.m4 (backup in $m4base/gnulib-comp.m4~)"
        if false; then
          cat "$tmpfile"
          echo
          echo "# gnulib-comp.m4 ends here"
        fi
        rm -f "$tmpfile"
      fi
    fi
  else
    if $doit; then
      echo "Creating $m4base/gnulib-comp.m4"
      mv -f "$tmpfile" "$destdir"/$m4base/gnulib-comp.m4
    else
      echo "Create $m4base/gnulib-comp.m4"
      cat "$tmpfile"
      rm -f "$tmpfile"
    fi
  fi

  if test -n "$inctests"; then
    # Create tests/Makefile.am.
    func_dest_tmpfilename $testsbase/Makefile.am
    func_emit_tests_Makefile_am > "$tmpfile"
    if test -f "$destdir"/$testsbase/Makefile.am; then
      if cmp "$destdir"/$testsbase/Makefile.am "$tmpfile" > /dev/null; then
        rm -f "$tmpfile"
      else
        if $doit; then
          echo "Updating $testsbase/Makefile.am (backup in $testsbase/Makefile.am~)"
          mv -f "$destdir"/$testsbase/Makefile.am "$destdir"/$testsbase/Makefile.am~
          mv -f "$tmpfile" "$destdir"/$testsbase/Makefile.am
        else
          echo "Update $testsbase/Makefile.am (backup in $testsbase/Makefile.am~)"
          rm -f "$tmpfile"
        fi
      fi
    else
      if $doit; then
        echo "Creating $testsbase/Makefile.am"
        mv -f "$tmpfile" "$destdir"/$testsbase/Makefile.am
      else
        echo "Create $testsbase/Makefile.am"
        rm -f "$tmpfile"
      fi
    fi
  fi

  rm -rf "$tmp"
  # Undo the effect of the previous 'trap' command. Some shellology:
  # We cannot use "trap - 0 1 2 3 15", because Solaris sh would attempt to
  # execute the command "-". "trap '' ..." is fine only for signal 0 (= normal
  # exit); for the others we need to call 'exit' explicitly. The value of $? is
  # 128 + signal number and is set before the trap-registered command is run.
  trap '' 0
  trap 'exit $?' 1 2 3 15

  echo "Finished."
  echo
  echo "You may need to add #include directives for the following .h files."
  (
   # First the #include <...> directives without #ifs, sorted for convenience.
   for module in $modules; do
     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
       :
     else
       func_get_include_directive "$module" | grep -v 'include "'
     fi
   done | LC_ALL=C sort -u
   # Then the #include "..." directives without #ifs, sorted for convenience.
   for module in $modules; do
     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
       :
     else
       func_get_include_directive "$module" | grep 'include "'
     fi
   done | LC_ALL=C sort -u
   # Then the #include directives that are surrounded by #ifs. Not sorted.
   for module in $modules; do
     if func_get_include_directive "$module" | grep '^#if' >/dev/null; then
       func_get_include_directive "$module"
     fi
   done
  ) | sed -e '/^$/d;' -e 's/^/  /'
  echo
  echo "Don't forget to"
  echo "  - add \"$sourcebase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
  if test -n "$inctests"; then
    echo "  - add \"$testsbase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
  fi
  sourcebase_dir=`echo "$sourcebase" | sed -n -e 's,/[^/]*$,/,p'`
  sourcebase_base=`basename "$sourcebase"`
  echo "  - mention \"${sourcebase_base}\" in SUBDIRS in ${sourcebase_dir}Makefile.am,"
  if test -n "$inctests"; then
    testsbase_dir=`echo "$testsbase" | sed -n -e 's,/[^/]*$,/,p'`
    testsbase_base=`basename "$testsbase"`
    echo "  - mention \"${testsbase_base}\" in SUBDIRS in ${testsbase_dir}Makefile.am,"
  fi
  echo "  - mention \"-I ${m4base}\" in ACLOCAL_AMFLAGS in Makefile.am,"
  echo "  - invoke ${macro_prefix}_EARLY in $configure_ac, right after AC_PROG_CC,"
  echo "  - invoke ${macro_prefix}_INIT in $configure_ac."
}

# func_create_testdir testdir modules
# Input:
# - auxdir          directory relative to destdir where to place build aux files
func_create_testdir ()
{
  testdir="$1"
  modules="$2"
  modules=`for m in $modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`

  # Determine final module list.
  func_modules_transitive_closure
  echo "Module list with included dependencies:"
  echo "$modules" | sed -e 's/^/  /'

  # Add the dummy module if needed.
  func_modules_add_dummy

  # Determine final file list.
  func_modules_to_filelist
  echo "File list:"
  echo "$files" | sed -e 's/^/  /'

  # Create directories.
  for d in `echo "$files" | sed -n -e 's,^\(.*\)/[^/]*,\1,p'`; do
    if test "$d" = build-aux; then
      mkdir -p "$testdir/$auxdir"
    else
      mkdir -p "$testdir/$d"
    fi
  done

  # Copy files or make symbolic links.
  for f in $files; do
    case "$f" in
      build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
      *) g="$f" ;;
    esac
    ln "$gnulib_dir/$f" "$testdir/$g" 2>/dev/null ||
    if test -z "$symbolic"; then
      cp -p "$gnulib_dir/$f" "$testdir/$g"
    else
      ln -s "$gnulib_dir/$f" "$testdir/$g"
    fi
  done

  # Create lib/Makefile.am.
  mkdir -p "$testdir/lib"
  func_emit_lib_Makefile_am > "$testdir/lib/Makefile.am"

  # Create m4/Makefile.am.
  mkdir -p "$testdir/m4"
  (echo "## Process this file with automake to produce Makefile.in."
   echo
   echo "EXTRA_DIST ="
   for f in $files; do
     case "$f" in
       m4/* )
         echo "EXTRA_DIST += "`echo "$f" | sed -e 's,^m4/,,'` ;;
     esac
   done
  ) > "$testdir/m4/Makefile.am"

  subdirs="lib m4"
  subdirs_with_configure_ac=""

  if test -f "$testdir"/m4/gettext.m4; then
    # Avoid stupid error message from automake:
    # "AM_GNU_GETTEXT used but `po' not in SUBDIRS"
    mkdir -p "$testdir/po"
    (echo "## Process this file with automake to produce Makefile.in."
    ) > "$testdir/po/Makefile.am"
    subdirs="$subdirs po"
  fi

  if test -n "$inctests"; then
    test -d "$testdir/tests" || mkdir "$testdir/tests"
    # Create tests/Makefile.am.
    sourcebase=lib
    m4base=m4
    testsbase=tests
    func_emit_tests_Makefile_am > "$testdir/tests/Makefile.am"
    # Create tests/configure.ac.
    (echo "# Process this file with autoconf to produce a configure script."
     echo "AC_INIT([dummy], [0])"
     echo "AC_CONFIG_AUX_DIR([../$auxdir])"
     echo "AM_INIT_AUTOMAKE"
     echo
     echo "AM_CONFIG_HEADER([config.h])"
     echo
     echo "AC_PROG_CC"
     echo "AC_PROG_INSTALL"
     echo "AC_PROG_MAKE_SET"
     echo "AC_PROG_RANLIB"
     echo
     if grep AC_GNU_SOURCE "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
       echo "AC_GNU_SOURCE"
       echo
     fi
     if grep gl_USE_SYSTEM_EXTENSIONS "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
       echo "gl_USE_SYSTEM_EXTENSIONS"
       echo
     fi
     if grep gl_LOCK "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
       echo "gl_LOCK"
       echo
     fi
     if test -z "$libtool"; then
       echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
     else
       echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
     fi
     if test "$auxdir" != "build-aux"; then
       sed_replace_build_aux='
         :a
         /AC_CONFIG_FILES(.*:build-aux\/.*)/{
           s|AC_CONFIG_FILES(\(.*\):build-aux/\(.*\))|AC_CONFIG_FILES(\1:../'"$auxdir"'/\2)|
           ba
         }'
       sed_replace_build_aux=`echo "$sed_replace_build_aux" | sed -e 1d -e 's/^ *//'`
     else
       sed_replace_build_aux=
     fi
     # We don't have explicit ordering constraints between the various
     # autoconf snippets. It's cleanest to put those of the library before
     # those of the tests.
     for module in $modules; do
       func_verify_nontests_module
       if test -n "$module"; then
         func_get_autoconf_snippet "$module" \
           | sed -e "$sed_replace_build_aux"
       fi
     done
     for module in $modules; do
       func_verify_tests_module
       if test -n "$module"; then
         func_get_autoconf_snippet "$module" \
           | sed -e "$sed_replace_build_aux"
       fi
     done
     echo
     # Usually tests/config.h will be a superset of config.h. Verify this by
     # "merging" config.h into tests/config.h; look out for gcc warnings.
     echo "AH_TOP([#include \"../config.h\"])"
     echo
     echo "AC_OUTPUT([Makefile])"
    ) > "$testdir/tests/configure.ac"
    subdirs="$subdirs tests"
    subdirs_with_configure_ac="$subdirs_with_configure_ac tests"
  fi

  # Create Makefile.am.
  (echo "## Process this file with automake to produce Makefile.in."
   echo
   echo "AUTOMAKE_OPTIONS = 1.5 foreign"
   echo
   echo "SUBDIRS = $subdirs"
   echo
   echo "ACLOCAL_AMFLAGS = -I m4"
  ) > "$testdir/Makefile.am"

  # Create configure.ac.
  (echo "# Process this file with autoconf to produce a configure script."
   echo "AC_INIT([dummy], [0])"
   if test "$auxdir" != "."; then
     echo "AC_CONFIG_AUX_DIR([$auxdir])"
   fi
   echo "AM_INIT_AUTOMAKE"
   echo
   echo "AM_CONFIG_HEADER([config.h])"
   echo
   echo "AC_PROG_CC"
   echo "AC_PROG_INSTALL"
   echo "AC_PROG_MAKE_SET"
   echo "AC_PROG_RANLIB"
   echo
   if grep AC_GNU_SOURCE "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
     echo "AC_GNU_SOURCE"
     echo
   fi
   if grep gl_USE_SYSTEM_EXTENSIONS "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
     echo "gl_USE_SYSTEM_EXTENSIONS"
     echo
   fi
   if grep gl_LOCK "$testdir"/m4/*.m4 >/dev/null 2>/dev/null; then
     echo "gl_LOCK"
     echo
   fi
   if test -z "$libtool"; then
     echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
   else
     echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
   fi
   if test "$auxdir" != "build-aux"; then
     sed_replace_build_aux='
       :a
       /AC_CONFIG_FILES(.*:build-aux\/.*)/{
         s|AC_CONFIG_FILES(\(.*\):build-aux/\(.*\))|AC_CONFIG_FILES(\1:'"$auxdir"'/\2)|
         ba
       }'
     sed_replace_build_aux=`echo "$sed_replace_build_aux" | sed -e 1d -e 's/^ *//'`
   else
     sed_replace_build_aux=
   fi
   for module in $modules; do
     func_verify_nontests_module
     if test -n "$module"; then
       func_get_autoconf_snippet "$module" \
         | sed -e "$sed_replace_build_aux"
     fi
   done
   echo
   if test -n "$subdirs_with_configure_ac"; then
     echo "AC_CONFIG_SUBDIRS(["`echo $subdirs_with_configure_ac`"])"
   fi
   makefiles="Makefile"
   for d in $subdirs; do
     # For subdirs that have a configure.ac by their own, it's the subdir's
     # configure.ac which creates the subdir's Makefile.am, not this one.
     case " $subdirs_with_configure_ac " in
       *" $d "*) ;;
       *) makefiles="$makefiles $d/Makefile" ;;
     esac
   done
   echo "AC_OUTPUT([$makefiles])"
  ) > "$testdir/configure.ac"

  # Create autogenerated files.
  (cd "$testdir"
   echo "executing ${AUTORECONF} --force --install"
   ${AUTORECONF} --force --install
  )
  if grep '^BUILT_SOURCES *+=' "$testdir/lib/Makefile.am" > /dev/null; then
    (cd "$testdir"
     ./configure
       cd lib
       echo 'built_sources: $(BUILT_SOURCES)' >> Makefile
       make built_sources
       cd ..
     make distclean
    )
  fi
}

# func_create_megatestdir megatestdir allmodules
# Input:
# - auxdir          directory relative to destdir where to place build aux files
func_create_megatestdir ()
{
  megatestdir="$1"
  allmodules="$2"
  if test -z "$allmodules"; then
    allmodules=`func_all_modules`
  fi

  megasubdirs=
  # First, all modules one by one.
  for onemodule in $allmodules; do
    func_create_testdir "$megatestdir/$onemodule" $onemodule
    megasubdirs="${megasubdirs}$onemodule "
  done
  # Then, all modules all together.
  # Except fnmatch-posix, which conflicts with fnmatch-gnu. FIXME.
  allmodules=`for m in $allmodules; do if test $m != fnmatch-posix; then echo $m; fi; done`
  func_create_testdir "$megatestdir/ALL" "$allmodules"
  megasubdirs="${megasubdirs}ALL"

  # Create Makefile.am.
  (echo "## Process this file with automake to produce Makefile.in."
   echo
   echo "AUTOMAKE_OPTIONS = 1.5 foreign"
   echo
   echo "SUBDIRS = $megasubdirs"
  ) > "$megatestdir/Makefile.am"

  # Create configure.ac.
  (echo "# Process this file with autoconf to produce a configure script."
   echo "AC_INIT([dummy], [0])"
   if test "$auxdir" != "."; then
     echo "AC_CONFIG_AUX_DIR([$auxdir])"
   fi
   echo "AM_INIT_AUTOMAKE"
   echo
   echo "AC_PROG_MAKE_SET"
   echo
   echo "AC_CONFIG_SUBDIRS([$megasubdirs])"
   echo "AC_OUTPUT([Makefile])"
  ) > "$megatestdir/configure.ac"

  # Create autogenerated files.
  (cd "$megatestdir"
   # Do not use "${AUTORECONF} --install", because autoreconf operates
   # recursively, but the subdirectories are already finished, therefore
   # calling autoreconf here would only waste lots of CPU time.
   echo "executing ${ACLOCAL}"
   ${ACLOCAL}
   echo "executing mkdir build-aux"
   mkdir build-aux
   echo "executing ${AUTOCONF}"
   ${AUTOCONF}
   echo "executing ${AUTOMAKE} --add-missing --copy"
   ${AUTOMAKE} --add-missing --copy
  )
}

case $mode in
  "" )
    func_fatal_error "no mode specified" ;;

  list )
    func_all_modules
    ;;

  import | update )

    # Where to import.
    if test -z "$destdir"; then
      destdir=.
    fi
    test -d "$destdir" \
      || func_fatal_error "destination directory does not exist: $destdir"

    # Prefer configure.ac to configure.in.
    if test -f "$destdir"/configure.ac; then
      configure_ac="$destdir/configure.ac"
    else
      if test -f "$destdir"/configure.in; then
        configure_ac="$destdir/configure.in"
      else
        func_fatal_error "cannot find $destdir/configure.ac"
      fi
    fi

    test -f "$destdir"/Makefile.am \
      || func_fatal_error "cannot find $destdir/Makefile.am"

    # Analyze configure.ac.
    guessed_auxdir="."
    guessed_libtool=
    my_sed_traces='
      s,#.*$,,
      s,^dnl .*$,,
      s, dnl .*$,,
      /AC_CONFIG_AUX_DIR/ {
        s,^.*AC_CONFIG_AUX_DIR([[ ]*\([^])]*\).*$,guessed_auxdir="\1",p
      }
      /A[CM]_PROG_LIBTOOL/ {
        s,^.*$,guessed_libtool=true,p
      }'
    eval `sed -n -e "$my_sed_traces" < "$configure_ac"`

    if test -z "$auxdir"; then
      auxdir="$guessed_auxdir"
    fi

    # Determine where to apply func_import.
    if test -n "$m4base"; then
      # Apply func_import to a particular gnulib directory.
      # Any number of additional modules can be given.
      if test ! -f "$destdir/$m4base"/gnulib-cache.m4; then
        # First use of gnulib in the given m4base.
        test -n "$supplied_libname" || supplied_libname=true
        test -n "$sourcebase" || sourcebase="lib"
        test -n "$docbase" || docbase="doc"
        test -n "$testsbase" || testsbase="tests"
        test -n "$macro_prefix" || macro_prefix="gl"
        test -n "$autoconf_minversion" || autoconf_minversion="$DEFAULT_AUTOCONF_MINVERSION"
      fi
      func_import "$*"
    else
      # Apply func_import to all gnulib directories.
      # To get this list of directories, look at Makefile.am. (Not at
      # configure, because it may be omitted from CVS. Also, don't run
      # "find $destdir -name gnulib-cache.m4", as it might be too expensive.)
      aclocal_amflags=`grep '^ACLOCAL_AMFLAGS[	 ]*=' "$destdir"/Makefile.am | sed -e 's/^ACLOCAL_AMFLAGS[	 ]*=\(.*\)$/\1/'`
      m4dirs=
      m4dirs_count=0
      m4dir_is_next=
      for arg in $aclocal_amflags; do
        if test -n "$m4dir_is_next"; then
          # Ignore absolute directory pathnames, like /usr/local/share/aclocal.
          case "$arg" in
            /*) ;;
            *)
              if test -f "$destdir/$arg"/gnulib-cache.m4; then
                m4dirs="$m4dirs $arg"
                m4dirs_count=`expr $m4dirs_count + 1`
              fi
              ;;
          esac
        else
          if test "X$arg" = "X-I"; then
            m4dir_is_next=yes
          else
            m4dir_is_next=
          fi
        fi
      done
      if test $m4dirs_count = 0; then
        # First use of gnulib in a package.
        # Any number of additional modules can be given.
        test -n "$supplied_libname" || supplied_libname=true
        test -n "$sourcebase" || sourcebase="lib"
        m4base="m4"
        test -n "$docbase" || docbase="doc"
        test -n "$testsbase" || testsbase="tests"
        test -n "$macro_prefix" || macro_prefix="gl"
        test -n "$autoconf_version" || autoconf_version="$DEFAULT_AUTOCONF_MINVERSION"
        func_import "$*"
      else
        if test $m4dirs_count = 1; then
          # There's only one use of gnulib here. Assume the user means it.
          # Any number of additional modules can be given.
          for m4base in $m4dirs; do
            func_import "$*"
          done
        else
          # Ambiguous - guess what the user meant.
          if test $# = 0; then
            # No further arguments. Guess the user wants to update all of them.
            for m4base in $m4dirs; do
              func_import
            done
          else
            # Really ambiguous.
            func_fatal_error "Ambiguity: to which directory should the modules be added? Please specify at least --m4-base=..."
          fi
        fi
      fi
    fi
    ;;

  create-testdir )
    if test -z "$destdir"; then
      func_fatal_error "please specify --dir option"
    fi
    mkdir "$destdir"
    test -d "$destdir" \
      || func_fatal_error "could not create destination directory"
    test -n "$auxdir" || auxdir="build-aux"
    func_create_testdir "$destdir" "$*"
    ;;

  create-megatestdir )
    if test -z "$destdir"; then
      func_fatal_error "please specify --dir option"
    fi
    mkdir "$destdir" || func_fatal_error "could not create destination directory"
    test -n "$auxdir" || auxdir="build-aux"
    func_create_megatestdir "$destdir" "$*"
    ;;

  test )
    test -n "$destdir" || destdir=testdir$$
    mkdir "$destdir" || func_fatal_error "could not create destination directory"
    test -n "$auxdir" || auxdir="build-aux"
    func_create_testdir "$destdir" "$*"
    cd "$destdir"
      mkdir build
      cd build
        ../configure
        make
        make check
        make distclean
        remaining=`find . -type f -print`
        if test -n "$remaining"; then
          echo "Remaining files:" $remaining 1>&2
          echo "gnulib-tool: *** Stop." 1>&2
          exit 1
        fi
      cd ..
    cd ..
    rm -rf "$destdir"
    ;;

  megatest )
    test -n "$destdir" || destdir=testdir$$
    mkdir "$destdir" || func_fatal_error "could not create destination directory"
    test -n "$auxdir" || auxdir="build-aux"
    func_create_megatestdir "$destdir" "$*"
    cd "$destdir"
      mkdir build
      cd build
        ../configure
        make
        make check
        make distclean
        remaining=`find . -type f -print`
        if test -n "$remaining"; then
          echo "Remaining files:" $remaining 1>&2
          echo "gnulib-tool: *** Stop." 1>&2
          exit 1
        fi
      cd ..
    cd ..
    rm -rf "$destdir"
    ;;

  extract-description )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_description "$module"
      fi
    done
    ;;

  extract-filelist )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_filelist "$module"
      fi
    done
    ;;

  extract-dependencies )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_dependencies "$module"
      fi
    done
    ;;

  extract-autoconf-snippet )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_autoconf_snippet "$module"
      fi
    done
    ;;

  extract-automake-snippet )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_automake_snippet "$module"
      fi
    done
    ;;

  extract-include-directive )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_include_directive "$module"
      fi
    done
    ;;

  extract-license )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_license "$module"
      fi
    done
    ;;

  extract-maintainer )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_maintainer "$module"
      fi
    done
    ;;

  extract-tests-module )
    for module
    do
      func_verify_module
      if test -n "$module"; then
        func_get_tests_module "$module"
      fi
    done
    ;;

  * )
    func_fatal_error "unknown operation mode --$mode" ;;
esac

exit 0
